# Dynamically Generated
@builtin "number.ne"
@builtin "string.ne"
@builtin "whitespace.ne"
@{%
    function compact(v) {
        if (Array.isArray(v)) {
            return v.reduce((a, v) => (v === null || v === undefined || (v && v.length === 0) ) ? a : (a.push(v), a), []);
        } else {
            return v;
        }
    }

    function flatten(v) {
        let r;
        if (Array.isArray(v)) {
            r = v.reduce((a,v) => (a.push(...((v && Array.isArray(v)) ? flatten(v) : [v])), a), []);
        } else {
            r = v;
        }
        r = compact(r);
        return r;
        }
%}


rule -> rule0 rule1 rule2 rule3 rule4 rule5 rule6 rule7 rule8 rule9 rule10 rule11 rule12 rule13 rule14 
{% ([ rule0,rule1,rule2,rule3,rule4,rule5,rule6,rule7,rule8,rule9,rule10,rule11,rule12,rule13,rule14 ]) => {
    return {
        $class: "org.accordproject.servicelevelagreement.TemplateModel",
        
        paymentPeriod : rule1,
        monthlyCapPercentage : rule3,
        yearlyCapPercentage : rule5,
        availability1 : rule7,
        serviceCredit1 : rule9,
        availability2 : rule11,
        serviceCredit2 : rule13
    };
}
%}

ROOT -> rule0 
{% ([ rule0 ]) => {
    return {
        
        
    };
}
%}



rule0 -> "1	Definitions\n\n1.1	In this Schedule:\n\nBusiness Day	means any day which is not a Saturday, Sunday or a public or bank holiday in England;\n\nChange Control Procedure	the procedure described in Change Control;\n\nmonth	means calendar month;\n\nService Credits	means the credits which become due to the Customer where the Service Levels are not achieved as set out in paragraph 3 and the Annex; and\n\nService Levels	means the service levels set out in the Annex.\n\n2	Service levels\n\n2.1	The Supplier shall provide the Services so as to meet or exceed the Service Levels set out in this Schedule.\n\n2.2	Service Levels may be added, deleted, or modified by the parties at any time during the Term, in accordance with the Change Control Procedure. For the avoidance of doubt, the Supplier shall not withhold or delay its consent to any changes to the Service Levels that are required to achieve a fair, accurate and consistent measurement of the Supplier’s performance in delivering the Services.\n\n3	Service credits\n\n3.1	If the Supplier fails to meet or exceed a Service Level, the Customer shall be entitled to a Service Credit in accordance with the provisions of this paragraph 3.\n\n3.2	Service Credits shall be applied as a deduction against the Customer’s next monthly invoice or, if there are insufficient charges to deduct from, shall be paid to the Customer within " 


rule1 -> Integer {% id %} # paymentPeriod 


rule2 -> " days.\n\n3.3	The amount of Service Credits credited (and/or paid) to the Customer with respect to all Service Level defaults occurring in a single month under this Agreement shall not exceed: " 


rule3 -> Double {% id %} # monthlyCapPercentage 


rule4 -> "%.\n\n3.4	The amount of Service Credits credited (and/or paid) to the Customer with respect to all Service Level defaults occurring in any 12–month period under this Agreement shall not exceed: " 


rule5 -> Double {% id %} # yearlyCapPercentage 


rule6 -> "%.\n\n3.5	The Supplier shall not charge the Customer for any work carried out by it in connection with remedying a Service Level default.\n\n3.6	Where a sum is expressed to be payable as a Service Credit the parties agree that:\n\n3.6.1	the Customer has a legitimate interest in ensuring that it can recover losses suffered as a result of the Supplier’s failure to meet the relevant Service Level; and\n\n3.6.2	the Service Credits set out in this Agreement are not out of all proportion to such interest.\n\n3.7	Any Service Credits that are deducted and/or paid are not to be taken into account for the purposes of the limitation on liability provisions set out in Limitation of liability.\n\n3.8	The payment of Service Credits is without prejudice to any other remedy available to the Customer, whether under this Agreement, common law, or in equity.\n\n4	Exclusions\n\n4.1	The Supplier shall be relieved of its liability in respect of any failure to provide the Services to the Service Levels if, and to the extent that, such failure is wholly and directly attributable to any of the following:\n\n4.1.1	a failure by the Customer to observe any of its obligations under this Agreement which have a direct impact upon the Supplier’s provision of the Services; or\n\n4.1.2	a Force Majeure event.\n\n5	Reporting\n\n5.1	The Supplier shall monitor its performance against the Service Levels and, within ten Business Days after the end of each month, shall prepare and submit to the Customer a report showing in detail its performance against the Service Levels in that previous month.\n\n5.2	The Supplier shall, at the Customer’s request, provide details of its performance against the Service Levels more frequently than monthly if the Customer, acting reasonably, has a concern as to service quality or any other aspect of the Supplier’s performance of this Agreement.\n\n5.3	A failure by the Supplier to monitor the Services or to provide the Customer with a monthly report or other details in accordance with this Schedule shall be deemed to be a Service Level default and the Supplier will be deemed to have failed to achieve those Service Levels in respect of which the Customer has failed to report.\n\nAnnex 1—Service levels\n\n| Service Level Description     | Target service level      | Service credit \n| Priority 1                    | " 


rule7 -> Double {% id %} # availability1 


rule8 -> "%                      |     " 


rule9 -> Double {% id %} # serviceCredit1 


rule10 -> "%\n| Priority 1                    | " 


rule11 -> Double {% id %} # availability2 


rule12 -> "%                       |     " 


rule13 -> Double {% id %} # serviceCredit2 


rule14 -> "%\n" 


ContractState -> String  __  String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractState",
        stateId : data[0],
        contract : data[2]
    };
}
%}


ContractModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractModel",
        contractId : data[0]
    };
}
%}


ClauseModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ClauseModel",
        clauseId : data[0]
    };
}
%}


Request -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Request",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Response -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Response",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


ErrorResponse -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ErrorResponse",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Payload -> ContractModel  __  Request  __  ContractState 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Payload",
        contract : data[0],
        request : data[2],
        state : data[4]
    };
}
%}


Success -> Response  __  ContractState  __  Event:+ 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Success",
        response : data[0],
        state : data[2],
        emit : data[4]
    };
}
%}


Failure -> ErrorResponse 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Failure",
        error : data[0]
    };
}
%}


MonthSummary -> Double  __  Double  __  Double  __  Double  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.servicelevelagreement.MonthSummary",
        monthlyServiceLevel : data[0],
        monthlyCharge : data[2],
        last11MonthCredit : data[4],
        last11MonthCharge : data[6],
        transactionId : data[8],
        timestamp : data[10]
    };
}
%}


InvoiceCredit -> Double  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.servicelevelagreement.InvoiceCredit",
        monthlyCredit : data[0],
        transactionId : data[2],
        timestamp : data[4]
    };
}
%}



# Basic types
NUMBER -> [0-9] 
{% (d) => {return parseInt(d[0]);}%}

DOUBLE_NUMBER -> NUMBER NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

MONTH -> DOUBLE_NUMBER
DAY -> DOUBLE_NUMBER
YEAR -> DOUBLE_NUMBER DOUBLE_NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

DATE -> MONTH "/" DAY "/" YEAR
{% (d) => {return '' + d[4] + '-' + d[0] + '-' + d[2]}%}

Word -> [\S]:*
{% (d) => {return d[0].join('');}%}

BRACKET_PHRASE -> "[" Word (__ Word):* "]" {% ((d) => {return d[1] + ' ' + flatten(d[2]).join(" ");}) %}

String -> dqstring {% id %}
Double -> decimal {% id %}
Integer -> int {% id %}
Long -> int {% id %}
Boolean -> "true" {% id %} | "false" {% id %}
DateTime -> DATE  {% id %}